'''
Filename: /Users/julio.liriano/GitPortal/serialTest/serialTest.py
Path: /Users/julio.liriano/GitPortal/serialTest
Created Date: Wednesday, October 2nd 2024, 5:00:37 pm
Author: julio.liriano

Copyright (c) 2024 Peloton Interactive Inc.
'''
from pyftdi import gpio
from pyftdi.ftdi import Ftdi

import time
import argparse as ap
import serial 
import ws2812b as ws
from ws2812b import SetColors

numLeds = 2

if "__main__" == __name__:
    arg_parser = ap.ArgumentParser(description="Serial Test", add_help=True, exit_on_error=True)   
    arg_parser.add_argument('-c', '--comPort', type=str, required=False, metavar='<selected COM device>', dest='comPort', default=None)
    args = arg_parser.parse_args()

##### WORKS #####
# ftdi = Ftdi()
# ftdi.open_from_url(url='ftdi:///1')

# # Set mode manually
# ftdi.set_bitmode(0, Ftdi.BitMode.CBUS)
# ftdi.set_cbus_direction(0b1111,0b1111)
# ftdi.set_baudrate(115200)

# for i in range(16):
#     print(i)
#     ftdi.set_cbus_gpio(i)
#     print(ftdi.read_pins())
#     time.sleep(.100)
#     ftdi.write_data(bytearray([i]))
##### WORKS #####


##### FAILS #####
# ftdi = Ftdi()
# ftdi.open_from_url(url='ftdi:///1')
# ftdi.set_bitmode(0, Ftdi.BitMode.RESET)
# ftdi.set_baudrate(2666666)
# ftdi.set_line_property(7, 1, 'N')
# print(f"Actual baud rate: {ftdi.baudrate}")
# #wr = bytearray([0x5b, 0x1b, 0x53, 0x13, 0x5a, 0x1a, 0x52, 0x12, 0x5b, 0x1b, 0x53, 0x13, 0x5a, 0x1a, 0x52, 0x12])
# wr = bytearray([0x12, 0x53, 0x12, 0x53, 0x12, 0x53, 0x12, 0x53])

# ftdi.write_data(wr)
##### FAILS #####

cl = ws.WS2812(args.comPort, numLeds)

for i in range (0, numLeds):
    cl[i] = ws.createSetColor(color=SetColors.Red, intensity = 0x10)
    cl.updateStrip()
    # # time.sleep(.050)
    # cl[i] = ws.createSetColor(color=SetColors.Black, intensity = 0xFF)

print('Done!')
time.sleep(5)

cl.setAll(color=ws.createSetColor(color=SetColors.Black, intensity = 0xFF))
cl.updateStrip()
time.sleep(1)
cl.close()